#!/home/artur/programs/tcl8.4.3-atkdebugger/unix/tclsh

# I do not use package require atkdebugger to make passible
# to do the test with make test without the need to install atkdebugger in
# tcl target library fist.
# normall after installation you should use package require atkdebugger

load libatkdebugger0.21.so

atk::debugproc

atk::debugproc debugproc

puts "debugproc introspection [atk::debugproc]"
puts "debuglevel without debug [atk::debuglevel]"

proc printExecutionPoint level {
    set res [atk::runplace [atk::debuglevel]]
    set source [lindex $res 0]
    set beginn [lindex $res 1]
    set len [lindex $res 2]
    set endexecution [expr {$beginn + $len}]
    set source "[string range $source 0 [expr {$beginn-1}]]>>>>[string range $source $beginn [expr {$endexecution-1}]]<<<<[string range $source $endexecution end]"
    puts $source
}

set debugCount 0

proc debugproc {} {
    global debugCount
    incr debugCount
    puts "Debugproc was invoked [atk::debuglevel] $debugCount"
    if {[catch {atk::stepInto}]} {
       global errorInfo
       puts $errorInfo
    }
    printExecutionPoint [atk::debuglevel]
}

proc example {} {
  set a 2
  set b [list $a $a]
}

puts "bp 1"
atk::halt
puts "bp 2"
set a 3
puts "bp 3"
set b [list 1 2 3 4]
puts "bp 4"
atk::halt
#foreach c $b {
#    lappend ret [expr {$c*$c}]
#}
puts "bp 5"
#puts $ret
puts "bp 6"
example
